<template>
  <div class="relative flex flex-col">
    <div class="endpoint-page__header bg-bgdsec p-8 sm:p-4 xs:p-4 rounded-32">
      <NodeTitle :node-info="nodeInfo" :loading="loading" />
      <NodeLink :node-info="nodeInfo" :loading="loading" class="mt-4 sm:mt-4" />
    </div>
    <div class="bg-bgdsec p-8 sm:p-4 xs:p-4 xs:pt-8 rounded-32 grow mt-4">
      <NodeCode :node-info="nodeInfo" :loading="loading" />
    </div>

    <transition name="modal-appear">
      <TheRenew v-show="renewDisplay" :node-info="nodeInfo" />
    </transition>
  </div>
</template>

<script>
import { getProject } from '@/api';
import NodeTitle from '@/components/views/endpoint/NodeTitle.vue';
import NodeLink from '@/components/views/endpoint/NodeLink.vue';
import NodeCode from '@/components/views/endpoint/NodeCode.vue';
import TheRenew from '@/components/views/endpoint/TheRenew.vue';

export default {
  name: 'EndpointPage',

  components: { NodeTitle, NodeLink, NodeCode, TheRenew },

  data() {
    return {
      nodeInfo: {},
      loading: false,
    };
  },

  computed: {
    renewDisplay() {
      return this.$store.state.system.renewDisplay;
    },

    userProjects() {
      return this.$store.state.auth.userProjects;
    },
  },

  mounted() {
    if (!this.$store.state.auth.isAuthorized) this.$router.replace('/');

    this.getProject();
  },

  beforeDestroy() {
    this.$store.commit('setCurrentApiKey', '');
  },

  methods: {
    async getProject() {
      this.loading = true;
      try {
        const res = await getProject(this.$route.params.key);
        this.nodeInfo = res.data.result;
        this.$store.commit('setCurrentApiKey', this.nodeInfo.api_key);
      } catch (err) {
        console.error(err);
        this.$store.commit('setCurrentApiKey', '');
        this.$router.replace('/not-found');
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>

<style lang="scss">
.endpoint-page {
}
</style>
